//#define F_CPU 9600000UL
#define F_CPU 128000UL

#include <avr/io.h>
#include <util/delay.h>

/*
   atTiny 13A
                   +---U---+
   RESET ADC0 PB5 -|1     8|- VCC
    CLKI ADC3 PB3 -|2     7|- PB2 SCK  ADC1
         ADC2 PB4 -|3     6|- PB1 MISO AIN1
              GND -|4     5|- PB0 MOSI AIN0
                   +-------+
*/

/*
	LED 0 -> PB 0
	LED 1 -> PB 1
	LED 2 -> PB 2
	LED 3 -> PB 3
	LED 4 -> PB 4
*/

/*
   ISP Pin
   
   TOP
    | GND  /RST |  < 1pin
    | MOSI SCK   ] 
    | VCC  MISO |
   
   BOTTOM
    | /RST GND  |
   [  SCK  MOSI |
    | MISO VCC  |
*/

uint32_t random_now;

void random_next() {
	//1ビット進める
	random_now = 
		(random_now << 1) | 
		((random_now >> 31 & 1) ^ (random_now >> 21 & 1) ^ (random_now >> 1 & 1) ^ (random_now >> 0 & 1));
}

int main(void)
{	
	//クロック = 9.6MHz

	CLKPR = 1 << CLKPCE;//ｸﾛｯｸ分周値変更許可
    CLKPR = 0;//64分周

	//クロック = 150KHz
	
	DDRB |= 0b00011111; //LEDピンを出力に設定する
	
	random_now = 1;//randomのseedは0以外
	
	char now_random = 0;
	char old_random = 0;

    while (1) 
    {
		//char out = 0;
		for(char n = 0; n < 2; n++)
		{
			do 
			{
				for(char i = 0; i < 32; i++ )
				{
					random_next();
				}
				now_random = random_now % 5;
			} while (now_random == old_random);
		
			PORTB |= (1 << now_random);//1つのLEDをONする
			old_random = now_random;
		}
		//PORTB |= out;
		_delay_ms(30);

		PORTB &= ~0b00011111;//すべてのLEDピンをOFF
		//_delay_ms(50);
    }
}

